%Template Matching
tar=imread('4.jpg');
temp=imread('temp.jpg');
imshowpair(tar,temp,'montage')
targ=rgb2gray(tar);
tempg=rgb2gray(temp);
cc=normxcorr2(tempg,targ);
figure, surf(cc), shading flat
[max_cc,imax]=max(abs(cc(:)));
[ypeak,xpeak]=ind2sub(size(cc),imax(1));
best_row=ypeak-(size(tempg,1)-1);
best_col=xpeak-(size(tempg,2)-1);
figure, imshow(tar)
m=(size(tempg,1)-1)
n=(size(tempg,2)-1)
imrect(gca, [best_col  best_row n m])

%%
% Build a Gaussian pyramid
I = imread('van.jpg');
figure, imshow(I)
I1 = impyramid(I, 'reduce');
figure, imshow(I1)
I2 = impyramid(I1, 'reduce');
figure, imshow(I2)
I3 = impyramid(I2, 'reduce');
figure, imshow(I3)
I4 = impyramid(I3, 'reduce');
figure, imshow(I4)

%% Build a Laplacian pyramid
I4 = imresize(I4,[size(I3,1) size(I3,2)]);
LP_3= I3-I4;
figure, imshow(LP_3)

I3 = imresize(I3,[size(I2,1) size(I2,2)]);
LP_2= I2-I3;
figure, imshow(LP_2)

I2 = imresize(I2,[size(I1,1) size(I1,2)]);
LP_1= I2-I1;
figure, imshow(LP_1)


%% Single-level discrete 2-D wavelet transform
im=imread('tiger.jpg');
X=rgb2gray(im);
wname = 'haar';
[CA,CH,CV,CD] = dwt2(X,wname,'mode','per');
% Display the vertical detail image and the lowpass approximation.
subplot(411)
imagesc(CA); title('Approximation');
colormap gray;
subplot(412)
imagesc(CH); title('Horizontal detail ');
colormap gray;
subplot(413)
imagesc(CV); title('Vertical detail');
colormap gray;
subplot(414)
imagesc(CD); title('Diagonal detail');
colormap gray;

% Multi-level discrete 2-D wavelet transform
[c,s]=wavedec2(X,2,'haar');
[H1,V1,D1] = detcoef2('all',c,s,1);
A1 = appcoef2(c,s,'haar',1);
V1img = wcodemat(V1,255,'mat',1);
H1img = wcodemat(H1,255,'mat',1);
D1img = wcodemat(D1,255,'mat',1);
A1img = wcodemat(A1,255,'mat',1);
[H2,V2,D2] = detcoef2('all',c,s,2);
A2 = appcoef2(c,s,'haar',2);
V2img = wcodemat(V2,255,'mat',1);
H2img = wcodemat(H2,255,'mat',1);
D2img = wcodemat(D2,255,'mat',1);
A2img = wcodemat(A2,255,'mat',1);
subplot(2,2,1);
imagesc(A1img);
colormap pink(255);
title('Approximation Coef. of Level 1');

subplot(2,2,2);
imagesc(H1img);
title('Horizontal detail Coef. of Level 1');

subplot(2,2,3);
imagesc(V1img);
title('Vertical detail Coef. of Level 1');

subplot(2,2,4);
imagesc(D1img);
title('Diagonal detail Coef. of Level 1');


